#!/bin/sh

echo "------------------------------------------------------"
echo "▼ドコモスマホ × 格安SIM テザリング有効化ツール"
echo "by Yusuke Sakakura"
echo "→http://mobilelaby.com/"
echo "------------------------------------------------------"
echo

tether_enable() {
    
    #設定値を取得
    ret=`./adb shell settings get global tether_dun_required`
    #取得した設定値を数値に変換する
    retNum=`echo "$ret" | sed 's/[^0-9]//g'`

        if [ "$ret" -a "$retNum" ] ; then
            if [ 0 -eq $retNum ] ; then 
        echo "→既にテザリングは有効化されています"
        elif [ 1 -eq $retNum ] ; then 
        ./adb shell settings put global tether_dun_required 0
        echo "→テザリングを有効化しました！"
        else
        echo "→接続された機種はテザリングの有効化に対応していません"
        fi
    else
        echo "→接続された機種はテザリングの有効化に対応していません（null）"
        return
    fi

}

tether_disable() {
    
    #設定値を取得
    ret=`./adb shell settings get global tether_dun_required`
    #取得した設定値を数値に変換する
    retNum=`echo "$ret" | sed 's/[^0-9]//g'`

        if [ "$ret" -a "$retNum" ] ; then
            if [ 0 -eq "$retNum" ] ; then 
        ./adb shell settings put global tether_dun_required 1
        echo "→テザリングを無効化しました！"
        elif [ 1 -eq  "$retNum" ] ; then
        echo "→既にテザリングは無効化されています"
        else
        echo "→接続された機種はテザリングの有効化に対応していません"
        fi
    else
        echo "→接続された機種はテザリングの有効化に対応していません（null）"
        return
    fi

}

tether_confirm () {
    #設定値を取得
    ret=`./adb shell settings get global tether_dun_required`
    #取得した設定値を数値に変換する
    retNum=`echo "$ret" | sed 's/[^0-9]//g'`

    if [ "$ret" -a "$retNum" ] ; then
        if [ 0 -eq "$retNum" ] ; then 
        echo "→テザリングは有効化されています"
        return 0
        elif [ 1 -eq  "$retNum" ] ; then
        echo "→テザリングは無効化されています"
        return 0
        else
        echo "→接続された機種はテザリングの有効化に対応していません"
        return 1
        fi
    else
        echo "→接続された機種はテザリングの有効化に対応していません（null）"
        return 1
    fi

}

connect_device() {
    echo "------------------------------------------------------"
    echo "！スマートフォンまたはタブレットをPCに接続してください"
    echo "！接続できない場合はデバイスを抜き差ししてください"
    echo "------------------------------------------------------"
    #スクリプトのパスを取得して移動
    script_dir="$(cd "$(dirname "${BASH_SOURCE:-${(%):-%N}}")"; pwd)"
    cd $script_dir
    ./adb kill-server
    ./adb start-server
    ./adb wait-for-device
    return 0
}

main () {

echo
echo "------------------------------------------------------"
echo "▼1〜3を入力してEnterキーを押してください"
echo "1.テザリングを有効化"
echo "2.テザリングを無効化する（元に戻す）"
echo "3.現在の設定を確認する    "
echo "4.終了する"
echo "------------------------------------------------------"
echo 

read menu

echo

case $menu in
    1)
        echo "------------------------------------------------------"
        echo "！テザリングを有効化します"
        echo "------------------------------------------------------"
        echo
        tether_enable
        main
        echo 
        ;;
    2)
        echo "------------------------------------------------------"
        echo "！テザリングを無効化して元に戻します"
        echo "------------------------------------------------------"
        echo
        tether_disable
        main
        echo 
        ;;
    3)
        echo "------------------------------------------------------"
        echo "！現在の状態を確認します"
        echo "------------------------------------------------------"
        echo
        tether_confirm
        main
        echo 
        ;;
    4)
        echo "------------------------------------------------------"
        echo "！終了します"
        echo "------------------------------------------------------"
        echo
        exit 0
        ;;
    *)
        echo "------------------------------------------------------"
        echo "！無効な文字が入力されました"
        echo "------------------------------------------------------"
        echo
        main
        ;;
esac
}

#デバイスを接続する
connect_device
#メインメニュー
main